import inspect
import os
import time

def _funcInfo(func):
    fileName = os.path.relpath(inspect.getsourcefile(func))
    return "\"{}\" ({})".format(func.__name__, fileName) 

def printcaller(start=0, recursions=None):
    def decorator(func):
        def inner(*args, **kwargs):
            import traceback
            import sys
            print "caller traceback for", _funcInfo(func)
            traceback.print_stack(sys._getframe(1 + start), limit=recursions)
            return func(*args, **kwargs)
        return inner
    return decorator

def benchmark(func):
    def timePrinter(*args, **kwargs):
        t1 = time.clock()
        res = func(*args, **kwargs)
        t2 = time.clock()
        print "benchmark for", _funcInfo(func), ": {0:.3f} ms".format((t2 - t1) * 1000.0)
        return res
    return timePrinter
