from PyQt5.QtCore import QPoint
from PyQt5.QtGui import QImage
from PyQt5.QtWidgets import QPushButton, QWidget
from lib.constants import ResPath
from widgets.signalconfig.waveconfiguration import WaveDialog


class TestWidget(QWidget):
    def __init__(self, handle, parent=None):
        QWidget.__init__(self, parent)

        self._handle = handle
        self._image = QImage(ResPath.icons + "pencil.png")
        
        QPushButton("Overlay Introduction", parent=self, clicked=self.overlayIntroduction)
        
        b2 = QPushButton("Overlay", parent=self, clicked=self.overlay)
        b2.move(0, 40)
        
        b2 = QPushButton("OverlayNoAnimation", parent=self, clicked=self.overlay2)
        b2.move(80, 40)
        
        bWave = QPushButton("WaveConfig", parent=self, clicked=self.showdialog)
        bWave.move(0, 80)
        
        bReset = QPushButton("Reset", parent=self, clicked=handle.reset)
        bReset.move(0, 120)

    def overlayIntroduction(self):
        text = """Recording seismic events is a mayor source of our knowledge about the interior of the earth:\n
from natural seismic sources initiated by earthquakes as well as technically generated sources elastic\n
and acoustic waves propagate through solids and fluids and are measured by geo- and hydrophones.\n
Analyzing many of these signals, the seismograms, allow to reconstruct the wave speed distribution\n
and the location of wave reflections, e.g., at the submarine ground and below. This information\n
characterizes the material distribution of the subsurface.\n
Here we illustrate maritime seismic exploration as it is used by industry, e.g., to find oil reservoirs\n
or to investigate the subsurface prior to the construction of offshore wind parks."""
        self._handle.getOverlay().addText((50, 100), text)
        self._handle.getOverlay().show()

    def overlay(self):
        images = (QImage(ResPath.icons + "pause.png"), QImage(ResPath.icons + "pencil.png"))
        pos = ((0, 0), (20, 500))
        self._handle.getOverlay().addImages(pos, images)
        self._handle.getOverlay().addText(((400, 100), (400, 200)), ("Test Text", "Test Text2"))
        self._handle.getOverlay().show()

    def overlay2(self):
        images = (QImage(ResPath.icons + "pause.png"), QImage(ResPath.icons + "pencil.png"))
        pos = ((0, 0), (20, 500))
        self._handle.getOverlay().addImages(pos, images)
        self._handle.getOverlay().addText((400, 100), "Test Text")
        self._handle.getOverlay().show(animate=False)

    def showdialog(self):
        d = WaveDialog(self)
        if d.exec_():
            # that is the resulting function:
            print d.getResult()

    def reset(self):
        pass
